;;   Copyright   : David Tschumperle
;;                 ( http://www.greyc.ensicaen.fr/~dtschump/  )
;;
;;   License     : CeCILL v2.0
;;                 ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html  )
;;
;;   This software is governed by the CeCILL  license under French law and
;;   abiding by the rules of distribution of free software.  You can  use,
;;   modify and/ or redistribute the software under the terms of the CeCILL
;;   license as circulated by CEA, CNRS and INRIA at the following URL
;;   "http://www.cecill.info ".
;;
;;   As a counterpart to the access to the source code and  rights to copy,
;;   modify and redistribute granted by the license, users are provided only
;;   with a limited warranty  and the software's author,  the holder of the
;;   economic rights,  and the successive licensors  have only  limited
;;   liability.
;;
;;   In this respect, the user's attention is drawn to the risks associated
;;   with loading,  using,  modifying and/or developing or reproducing the
;;   software by the user in light of its specific status of free software,
;;   that may mean  that it is complicated to manipulate,  and  that  also
;;   therefore means  that it is reserved for developers  and  experienced
;;   professionals having in-depth computer knowledge. Users are therefore
;;   encouraged to load and test the software's suitability as regards their
;;   requirements in conditions enabling the security of their systems and/or
;;   data to be ensured and,  more generally, to use and operate it in the
;;   same conditions as regards security.
;;
;;   The fact that you are presently reading this means that you have had
;;   knowledge of the CeCILL license and that you accept its terms.
;;
;;   Thanks to NIXNINE for the tutorial this script follows
;;   GMIC can be downloaded from http://sourceforge.net/projects/gmic/files/
;;   you will need version 1.5.0.2 or later with Tom Keil's metal look filter



(define (script-fu-metallica                                      
                                      text                                       
                                      font 
                                      size
                                      grow
                                      type
                                      plating
                                      3d-fgd-height
                                      x-angle
                                      bev-width
                                      depth                                      
                                      bkg-type 
                                      pattern
                                      bkg-color
                                      conserve)
  (let* (         
         (image (car (gimp-image-new 256 256 RGB)))
         
         (border (/ size 4))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
         (inner-bevel-layer 0)
         (bkg-layer 0) 
         (azimuth 135)
         (elevation 35)         
         (postblur 3.0)
         (lmode 0)
         (up 1)
         (inner 1)         
         (shape 0)
         (prenoise 0)        
         (opacity 100)
         (gloss 10)
         (ialpha 0)
         )
    (gimp-context-push)

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text 158 TRUE 632 PIXELS font)))
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)    
    (set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)

;;;;Expand the font if needed
    (if (> grow 0)
           (begin
    (gimp-selection-layer-alpha text-layer)
    (gimp-edit-clear text-layer)
    (gimp-selection-grow image grow)
    (gimp-context-set-foreground '(0 0 0))
    (gimp-edit-fill text-layer FOREGROUND-FILL)
    (gimp-selection-none image)
           )
    )
     
;;;;Add new layer with Bevel
    (if (= type 0)
		(begin
    (gimp-selection-layer-alpha text-layer)
    (gimp-image-set-active-layer image text-layer)    
    (set! inner-bevel-layer (car (gimp-layer-new image width height RGBA-IMAGE "Inner bevel" 100 NORMAL-MODE)))
    (gimp-image-add-layer image inner-bevel-layer -1)
    (gimp-image-set-active-layer image inner-bevel-layer)    
    (gimp-context-set-foreground '(0 0 0))
    (gimp-context-set-background '(255 255 255))
    (gimp-edit-fill inner-bevel-layer FOREGROUND-FILL)    
    (gimp-selection-shrink image 1)
    (gimp-selection-feather image bev-width)
    (gimp-selection-shrink image (- (/ bev-width 2) 1))
    (gimp-edit-fill inner-bevel-layer BACKGROUND-FILL)
    (gimp-selection-all image)
    (gimp-invert inner-bevel-layer)
    (plug-in-emboss RUN-NONINTERACTIVE image inner-bevel-layer azimuth elevation depth 1);Emboss

;;;;gloss the bevel-layer    
     (gimp-curves-spline inner-bevel-layer 0 16 #(0 0 63 73 95 125 127 31 156 188 191 151 223 227 255 255))  
     (plug-in-gauss-rle RUN-NONINTERACTIVE image inner-bevel-layer postblur 1 1)
 
;;;;Clean up the layers
    (gimp-selection-layer-alpha text-layer)
    (gimp-selection-invert image)
    (gimp-edit-clear inner-bevel-layer)
    (gimp-selection-invert image)


    
;;;;Color the bevel layer     
; *******************************************start GMIC Metallic look



(let*
				(
					;; Matching variables
					(metal (car (gimp-layer-copy inner-bevel-layer TRUE)))
                           (plate 0)			
				)
		
				;; Add a layer
				(gimp-image-add-layer image metal -1)
                                
                     
				;; name the layer
				(gimp-drawable-set-name metal "Metal")
                     
                     (if (= plating 0) (set! plate 2))
                     (if (= plating 1) (set! plate 3))
                     (if (= plating 2) (set! plate 1))
                     (if (= plating 3) (set! plate 0))
                     (if (= plating 4) (set! plate 4))			
						
				;; Render Metallic look using G'MIC.
				(plug-in-gmic 1 image metal 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_tk_metallic 1,0,"
                                (number->string plate)  
					)
				)         				
			)
        (gimp-image-lower-layer-to-bottom image text-layer)
        (gimp-selection-none image) 
                      
; *******************************************end Metallic look
           )
     )


; *******************************************start 3 Dimensional Image
;
(if (= type 1)
		(begin
	
			(let*
				(
					;; Matching variables
					(3d_fgd (car (gimp-layer-copy text-layer TRUE)))
                           (txt-width (car (gimp-drawable-width text-layer)))
				      (txt-height (car (gimp-drawable-height text-layer)))
                           (3d-height 3d-fgd-height)
                           (plate 0)                           
				)
		
				;; Add a layers
                      (gimp-image-add-layer image 3d_fgd -1)
                     
				;; name the layers
				(gimp-drawable-set-name 3d_fgd "3D_fgd")
                     			
						
				;; Render extrude3d using G'MIC.
				(plug-in-gmic 1 image 3d_fgd 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_extrude3d " 
                                (number->string 3d-height) ",512,0.6,"
                                (number->string txt-width) ","
                                (number->string txt-height) ",0.88,"
                                (number->string x-angle) ",0,0,45,0,0,-100,0.50,0.70,4"                                
					)
				)
                     (gimp-selection-layer-alpha 3d_fgd)
                     (if (= plating 0) (set! plate 2))
                     (if (= plating 1) (set! plate 3))
                     (if (= plating 2) (set! plate 1))
                     (if (= plating 3) (set! plate 0))
                     (if (= plating 4) (set! plate 4))			
						
				;; Render Metallic look using G'MIC.
				(plug-in-gmic 1 image 3d_fgd  1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_tk_metallic 1,0,"
                                (number->string plate)  
					)
				)         
                      (gimp-image-lower-layer-to-bottom image text-layer)
                      (gimp-drawable-set-visible text-layer FALSE)
                      (gimp-selection-none image)                      
               )
; *******************************************end 3 Dimensional Image
           )
   )         

;;;;Set Background Type and fill        
    (if (= bkg-type 1);;Pattern
		(begin
    (gimp-context-set-pattern pattern)
    (gimp-drawable-fill bkg-layer PATTERN-FILL)
           )
    )
    (if (= bkg-type 0);;Color
		(begin
    (gimp-context-set-background bkg-color)
    (gimp-drawable-fill bkg-layer BACKGROUND-FILL)
           )
    )

;;;;Finish the Image   
    ;;Scale Image to it's original size and merge the layers
    (gimp-image-scale-full image final-width final-height 2)

    (if (= conserve FALSE)
		(begin
    (gimp-drawable-set-visible text-layer TRUE)
    (gimp-image-merge-visible-layers image  CLIP-TO-IMAGE)    
           )
    )

    (gimp-context-pop)   

    (gimp-display-new image)

    )
  ) 
(script-fu-register "script-fu-metallica"
  "Metallica"
  "Create an image with a Metallic text Logo, (uses GMIC)"
  "Graechan"
  "Graechan"
  "October 2011"
  ""  
  SF-STRING     "Text"               "Metallica!"  
  SF-FONT       "Font"               "Sans"  
  SF-ADJUSTMENT "Font size (pixels)" '(100 25 600 1 1 0 1)
  SF-ADJUSTMENT "Expand theFont if needed" '(0 0 6 1 1 0 1)
  SF-OPTION "Image Type" '("Bevelled" "3 Dimensional")
  SF-OPTION "Plating Type" '("Copper" "Bronze" "Gold" "Silver" "Blue Steel")
  SF-ADJUSTMENT "3D-Text-height" '(70 1 256 0.1 1 1 0)
  SF-ADJUSTMENT "'X' Angle" '(45 0 270 0.1 1 1 0)
  SF-ADJUSTMENT "Bevel Width" '(50 1 100 1 10 0 0)
  SF-ADJUSTMENT "Bevel Depth" '(30 1 60 1 10 0 0)  
  SF-OPTION "Background Type" '("Color" "Pattern" "None")
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-COLOR      "Background color"         '(0 0 0)
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-metallica"
  "<Image>/File/Create/Logos"
  )